package com.steerinfo.pretrack.prehookscale.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.pretrack.prehookscale.model.PreHookScale;
import com.steerinfo.pretrack.prehookscale.service.IPreHookScaleService;
import com.steerinfo.pretrack.prerailwayscale.model.PreRailwayScale;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.math.BigDecimal;

/**
 * PreHookScale RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-01-21 11:24
 * 类描述
 * 修订历史：
 * 日期：2022-01-21
 * 作者：generator
 * 参考：
 * 描述：PreHookScale RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/prehookscales")
public class PreHookScaleController extends BaseRESTfulController {

    @Autowired
    IPreHookScaleService preHookScaleService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("prehookscale:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<PreHookScale> list = preHookScaleService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("prehookscale:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<PreHookScale> list = preHookScaleService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据PreHookScale对象创建")
    @ApiImplicitParam(name = "preHookScale", value = "详细实体preHookScale", required = true, dataType = "PreHookScale")
    //@RequiresPermissions("prehookscale:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute PreHookScale model){
        PreHookScale preHookScale = preHookScaleService.add(model);
        return success(preHookScale);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("prehookscale:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        PreHookScale preHookScale = preHookScaleService.getById(id);
        return success(preHookScale);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的preHookScale信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "preHookScale", value = "详细实体preHookScale", required = true, dataType = "PreHookScale")
    })
    //@RequiresPermissions("prehookscale:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody PreHookScale model){
        model.setId(id);
        PreHookScale preHookScale = preHookScaleService.modify(model);
        return success(preHookScale);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("prehookscale:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  preHookScaleService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("prehookscale:view")
    @GetMapping(value = "/listLikeRailwayNo/")
    public RESTfulResult listLikeRailwayNo(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<PreHookScale> list = preHookScaleService.queryLikeForRailwayNo(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value = "获取预报信息", notes = "根据车号获取预报信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", dataType = "Integer")
    })
    @GetMapping(value = "/select")
    public RESTfulResult selectlist(@RequestParam String railwayNo, Integer pageNum, Integer pageSize) {
        RESTfulResult rm = failed();
        try {
            PageList<PreHookScale> pageInfo = preHookScaleService.selectlist(railwayNo, pageNum, pageSize);
            return success(pageInfo);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        }
        return rm;
    }

    @ApiOperation(value = "获取预报信息", notes = "根据车号获取预报信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", dataType = "Integer")
    })
    @PostMapping(value = "/selectPre")
    public RESTfulResult selectPre(@RequestBody HashMap map) {
        RESTfulResult rm = failed();
        try {
            PageList<PreHookScale> pageInfo = preHookScaleService.selectPre(map);
            return success(pageInfo);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        }
        return rm;
    }
}
